clear all
close all
clc

myTic = tic;

generatePath;

myPath = '/lab/raid/models/saliencyDetection/';


%%%%% IDX for ASD
% ----------------------------- Small images ---------------------
smallIdx = [   12    16    74    89    90   102   105   126   143   175   176   180   190   207   237   260   263   286   304   309   311   315   318   323   327   330   336   340 ...
   351   353   357   377   387   391   393   394   398   409   416   422   424   438   444   458   463   475   494   501   504   507   514   528   529   541   544   558 ...
   568   581   589   597   604   608   616   625   628   634   637   645   681   682   685   713   727   730   750   754   783   793   806   809   846   855   859   872 ...
   915   931   947   962   971   983 ];

% ----------------------------- Big images ---------------------
bigIdx = [ 30    43    60    61    62    64    78    79    82    98   120   125   128   170   181   194   197   198   199   218   253   268   273   284   302   322   333   343 ...
   345   349   350   354   360   368   381   383   396   399   425   431   454   456   468   517   543   560   590   607   636   690   706   731   733   755   812   881 ...
   912   981   984];
   


datasetUsed = { ...
    'ASD'
%     'MSRA'
%     'SED'
%     'SOD'
    };

modelUsed = { ...
    % models that we have
%     'FTS' % is AC?
%     'Goferman'
%     'EDS'
%     'CBsal'
%     'Materias'
%     'salLiu'
    
    % some precomputed models
    'AC'
    'CA'
    'FT'
    'GB'
    'HC'
    'IT' % Itti model
    'LC'
    'MZ'
    'RC'
    'RCC' % Thresholded version of RC
    'SR'
    
    % MEP map (average dataset groundtruth)
%     'MEP'
    };

% loop dataset
for ds=1:length(datasetUsed)
    eval(['imName = ' datasetUsed{ds} 'getList;'])
    
    scorePRpr = cell(length(imName),length(modelUsed)); %precision
    scorePRre = cell(length(imName),length(modelUsed)); %recall
    scoreROCt = cell(length(imName),length(modelUsed)); %tpp?
    scoreROCf = cell(length(imName),length(modelUsed)); %fpp?
    % loop image
    for imNo = smallIdx%1:length(imName)
        eval(['[imBox imEachGT imAllGT] = ' datasetUsed{ds} 'getBox(imName{imNo});'])
        
        % loop models
        for mm=1:length(modelUsed)
            printLog(myTic,'dataset',datasetUsed{ds},'| imgNo',imNo,'/',length(imName),'| model',modelUsed{mm})
            
            if strcmp(modelUsed{mm},'MEP')
                theName = [myPath 'output/MEP_' datasetUsed{ds} '.mat'];
            else
                theName = [myPath 'output/' modelUsed{mm} '/' datasetUsed{ds} '/' rmExt(imName{imNo}) '.mat'];
            end
            if exist(theName,'file')
                load(theName);
                tPR = cell(length(imEachGT));
                tROC= cell(length(imEachGT));
                for me = 1:length(imEachGT)
                    % calc PR + ROC
                    [tPR{me} tROC{me}] = calcPR(SM,imEachGT{me});
                end
                clear SM;
                
                w=vertcat(tPR{:});
                a=w(1:2:end,:); %precision
                scorePRpr{imNo,mm}=mean(a,1);
                b=w(2:2:end,:); %recall
                scorePRre{imNo,mm}=mean(b,1);
                
                w=vertcat(tROC{:});
                a=w(1:2:end,:); %tpp
                scoreROCt{imNo,mm}=mean(a,1);
                b=w(2:2:end,:); %fpp
                scoreROCf{imNo,mm}=mean(b,1);
            end
        end
    end
    
    Fmeasure = zeros(length(modelUsed),1);
    beta=.3; % whats this?
    figure; hold on
    for mm=1:length(modelUsed)
       pr = vertcat(scorePRpr{:,mm});
       re = vertcat(scorePRre{:,mm});
       % remove all NaNs
       pr(isnan(pr)) = 0;
       re(isnan(re)) = 0;
       plot(mean(re),mean(pr),'color',rand(1,3));
       Fmeasure(mm) = ((1+ beta)*mean2(pr) * mean2(re)) / (beta*mean2(re) + mean2(pr));
    end
    hold off
    ylim([0 1])
    xlim([0 1])
    xlabel('recall')
    ylabel('precision')
    legend(modelUsed);
    
    figure;
    bar(Fmeasure)
    set(gca, 'XTick',  1:length(modelUsed))
    set(gca, 'XTickLabel', modelUsed)
    
    aucs = zeros(length(modelUsed),1);
    figure; hold on
    for mm=1:length(modelUsed)
       tpp = vertcat(scoreROCt{:,mm});
       fpp = vertcat(scoreROCf{:,mm});
       % remove all NaNs
       tpp(isnan(tpp)) = 0;
       fpp(isnan(fpp)) = 0;
       plot(mean(fpp),mean(tpp),'color',rand(1,3));
       aucs(mm) = -trapz(mean(fpp),mean(tpp));
    end
    plot(0:.1:1,0:.1:1,'k', 'linewidth',2)
    hold off
    ylim([0 1])
    xlim([0 1])
    ylabel('true positive')
    xlabel('false positive')
    legend(modelUsed);
    
    figure;
    bar(aucs)
    set(gca,'ylim',[.5 1])
    set(gca,'xlim',[.5 length(modelUsed)+.5])
    set(gca, 'XTick',  1:length(modelUsed))
    set(gca, 'XTickLabel', modelUsed)
    
% %     save(['score/' datasetUsed{ds} '_' date '.mat'],'scorePRpr','scorePRre','scoreROCt','scoreROCf','modelUsed')
end