% a testing to combine the functions
% function combineMaps()
clear all
close all
clc


generatePath;
myTic = tic;
myPath = '/lab/raid/models/saliencyDetection/';

% combining method
% 1 = + (addition)
% 2 = x (multiplication)
combineMethod = 2;

% converting from normalized input to something
% 1 = linear (no conversion)
% 2 = 1/log(x)
% 3 = exp(x^3)
combineTranslation = 1;



datasetUsed = { ...
    'ASD'
    'MSRA'
    'SED'
    'SED2'
    'SOD'
    };


theModel = { ...
%     % models that we have (have code) = all datasets calculated
%     'Goferman'   % CA      . M  . max 250 . Gofferman et.al ICVS 2008 . All
%     'EDS'        % EDS     . MC . orig    . Rosin et.al PRx/2009      . All
    'CBsal'      % CBSAL   . MC . orig    . Jiang et.al BMVC 2011     . All
%     'Materias'   % JL      . M  . orig    . Jian Li BMVC 2011         . All
%     'salLiu'     % LIU     . MC . max 200 . Liu et al. CVPR 2007      . All
    'SVO'        % SVO     . MC . orig    . Chang et al. ICCV 2011    . All
%     'MSSS'       % MSSS    . M  . orig    . Achanta ICIP 2008         . All
%     'AC'         % AC      . M  . orig    . Achanta ICVS 2008         . All
%     'FTS'        % FT      . M  . orig    . Achanta CVPR 2009         . All
%     'MichalGazit'% GAZIT   . M  . orig    . Gazit et.al ECCV2010      . All
%     % some precomputed models
%     %%%%%%'CA' % ASD only- This is Gofferman, Just keep this.
%     %%%%%%'RCC' % Thresholded version of RC, ignore this
%     'MZ'         % MZ      . S  . orig    . Ma and Zhang 2003         . ASD only
%     'Valenti'    % VALENTI . S  . orig    . Valenti et.al ICCV 2009   . ASD and MSRA only
%     'DAKlein'    % BITS    . S  . orig    . Klein & Frintrop ICCV 2011. All
%     'PMehrani'   % MV      . S  . orig    . Mehrani et.al BMVC 2010   . ASD and SED1 only
%     'LiuICIP'    % LIU-ICIP. S  . orig    . Liu et.al ICIP 2010       . ASD only
%     'LiuIETIP'   % LIU-TiP . S  . orig    . Liu et.al TiP 2011        . ASD only
%     % precomputed on windoze machine
%     %%%%%% 'FT' % = FTS, ignore this model
%     %%%%%% 'SR' % This is the same as HouCVPR
%     'HC'         % HC      . C  . orig    . Meng Wang et.al CVPR 2011 . All
%     'LC'         % LC      . C  . orig    . Zhai and Shah ACM-M 2006  . All
    %'RC'         % RC      . C  . orig    . Meng Wang et.al CVPR 2011 . All
%     %partial result, maybe biased due to train&test on same dataset but different files
%     'JiaLiSal'   % JIA-LI  . S  . 1/16    . Jia Li et.al IJCV 2010    . Partial ASD and MSRA
%     
%     
%     % Saliency modeling models (for fixation prediction)
%     'SAIM'       % AIM     . M  . 1/2     .
%     'SHouCVPR'   % SR      . M  . 64x64   . SRM % SKIP This as it is the same as SR
%     'SHouNIPS'   % ICL     . M  . orig    .
%     'SSUN'       % SUN     . M  . 1/2 - N .
%     'SAWS'       % AWS     . M  . 1/2     .
%     'SPQFT'      % PQFT    . M  . 400x400 .
%     'SGBVS'      % GBVS    . M  . orig    .have problem when the image is under 128x128, same as GB
%     'SITTI'      % ITTI    . C  . 1/16    .Itti model - same as IT
%     'SSEO'       % SDSR    . M  . orig    .
%     'SJudd'      % Judd    . M  . orig    .
%     
%     
%     % MAP map (Mean Annotation Map)
%     'MEP'

%     % segmenters, not salient object detections
%     'SRS1' % SRS . Christian's model, SRS# where # is the #-th salient point
%     %     'SRS2'
%     %     'SRS3'
%     %     'SRS4'
%     %     'SRS5'
%     'Mishra' % MISHRA .
    };

modelName = 'CMAP';
modelName = [modelName num2str(length(theModel))]; % number of models involved here
if (combineMethod==1); modelName = [modelName 'p'];
elseif (combineMethod==2); modelName = [modelName 'm'];
end
if (combineTranslation==1); modelName = [modelName 'lin'];
elseif (combineTranslation==2); modelName = [modelName 'log'];
elseif (combineTranslation==3); modelName = [modelName 'exp'];
end

for dtset=1:length(datasetUsed)
    
theDataset = datasetUsed{dtset};

printLog(myTic,'directory check:',theDataset)
if ~exist([myPath 'output/' modelName],'dir')
    mkdir([myPath 'output/' modelName]);
end
if ~exist([myPath 'output/' modelName '/' theDataset],'dir')
    mkdir([myPath 'output/' modelName '/' theDataset]);
end

eval(['imName = ' theDataset 'getList;'])
for imNo = 1:length(imName)
    printLog(myTic,'dataset',theDataset,'| imgNo',imNo,'/',length(imName))
    theName = rmExt(imName{imNo});
    eval(['im=' theDataset 'getPic(imName{imNo});'])
    imSize=[size(im,1) size(im,2)];
    mySM = ones(imSize);
    for i=1:length(theModel)
        load(['output/' theModel{i} '/' theDataset '/' theName '.mat']);
        if size(SM,3) > 1
            SM = rgb2gray(SM);
        end
        tSM = imresize(double(SM),imSize,'nearest');
        tSM = tSM - min(min(tSM));
        tSM = tSM / max(max(tSM));
        if (combineTranslation==1)
            % do nothing
        elseif (combineTranslation==2);
            tSM = -1 ./ log(tSM./2); % divide by 2 to prevent 1/log(1) = inf
        elseif (combineTranslation==3);
            tSM = exp(tSM .^ 3);
        end
        
        if (combineMethod==1)
            mySM = mySM + tSM;
        elseif (combineMethod==2)
            mySM = mySM .* (tSM + .0001);
        end
    end
    clear SM
    SM = mySM;
    save([myPath 'output/' modelName '/' theDataset '/' rmExt(imName{imNo}) '.mat'],'SM');
end

% end
end