clear all
close all
clc

myTic = tic;

generatePath;

myPath = '/lab/raid/models/saliencyDetection/';

datasetUsed = { ...
%     'ASD'
    'MSRA'
%     'SED'
%     'SED2'
%     'SOD'
    };

modelUsed = { ...
    'SRS1' %salient region segmenter
    'SRS2'
    'SRS3'
    'SRS4'
    'SRS5'
    };

salSRS = '/lab/tmpir/u/dicky/saliency/bin/test-SalientRegionSegmenter';
outPath = '/lab/ilab/1/cache/';

for ds=1:length(datasetUsed)
    
    %directory check
    printLog(myTic,'directory check:',datasetUsed{ds})
    for mm=1:length(modelUsed)
        if ~exist([myPath 'output/' modelUsed{mm}],'dir')
            mkdir([myPath 'output/' modelUsed{mm}]);
        end
        if ~exist([myPath 'output/' modelUsed{mm} '/' datasetUsed{ds}],'dir')
            mkdir([myPath 'output/' modelUsed{mm} '/' datasetUsed{ds}]);
        end
    end
    
    eval(['imName = ' datasetUsed{ds} 'getList;'])
    for imNo = 1:length(imName)
        eval(['[imData imPath]= ' datasetUsed{ds} 'getPic(imName{imNo});'])
        for mm=1:length(modelUsed)
            printLog(myTic,'dataset',datasetUsed{ds},'| imgNo',imNo,'/',length(imName),'| model',modelUsed{mm})
            if ~exist([myPath 'output/' modelUsed{mm} '/' datasetUsed{ds} '/' rmExt(imName{imNo}) '.mat'],'file')
                %eval(['SM = ' modelUsed{mm} '(imData);'])
                
                justName = rmExt(imName{imNo});
                if ~exist([outPath justName '_objMask_000000.png'],'file')
                    %do saliency
                    unix([salSRS ' --in=' imPath ' --out=null ' outPath justName]);
                end
                
                % the SRS not always have 5 images as output
                mySRSname = [outPath justName '_objMask_' num2str(mm-1,'%.6d') '.png'];
                if exist(mySRSname,'file');
                    SM = imread(mySRSname);
                    save([myPath 'output/' modelUsed{mm} '/' datasetUsed{ds} '/' rmExt(imName{imNo}) '.mat'],'SM');
                end
            end
        end
    end
end

