clear all
close all
clc

myTic = tic;

generatePath;

myDataset = { ...
%     'ASD'
%     'MSRA'
%     'SED'
%     'SED2'
%     'SOD'
    'Ehinger'
    };
numSampleImg = 8;

% Info: 'modelName' % ModelAcronym . Code . Size . Citation . Dataset avail
% * code: M=matlab only, MC=matlab+C, C=C/C++, S=provided
modelUsed = { ...
%     % models that we have (have code) = all datasets calculated
%     'Goferman'   % CA      . M  . max 250 . Gofferman et.al ICVS 2008 . All
%     'EDS'        % EDS     . MC . orig    . Rosin et.al PRx/2009      . All
%     'CBsal'      % CBSAL   . MC . orig    . Jiang et.al BMVC 2011     . All
%     'Materias'   % JL      . M  . orig    . Jian Li BMVC 2011         . All
%     'salLiu'     % LIU     . MC . max 200 . Liu et al. CVPR 2007      . All
%     'SVO'        % SVO     . MC . orig    . Chang et al. ICCV 2011    . All
%     'MSSS'       % MSSS    . M  . orig    . Achanta ICIP 2008         . All
%     'AC'         % AC      . M  . orig    . Achanta ICVS 2008         . All
%     'FTS'        % FT      . M  . orig    . Achanta CVPR 2009         . All
%     'MichalGazit'% GAZIT   . M  . orig    . Gazit et.al ECCV2010      . All
%     % some precomputed models
%     %%%%%%'CA' % ASD only- This is Gofferman, Just keep this.
%     %%%%%%'RCC' % Thresholded version of RC, ignore this
%     'MZ'         % MZ      . S  . orig    . Ma and Zhang 2003         . ASD only
%     'Valenti'    % VALENTI . S  . orig    . Valenti et.al ICCV 2009   . ASD and MSRA only
%     'DAKlein'    % BITS    . S  . orig    . Klein & Frintrop ICCV 2011. All
%     'PMehrani'   % MV      . S  . orig    . Mehrani et.al BMVC 2010   . ASD and SED1 only
%     'LiuICIP'    % LIU-ICIP. S  . orig    . Liu et.al ICIP 2010       . ASD only
%     'LiuIETIP'   % LIU-TiP . S  . orig    . Liu et.al TiP 2011        . ASD only
%     'MengW'      % MENG    . S  . orig    .                           . ASD only
%     % precomputed on windoze machine
%     %%%%%% 'FT' % = FTS, ignore this model
%     %%%%%% 'SR' % This is the same as HouCVPR
%     'HC'         % HC      . C  . orig    . Meng Wang et.al CVPR 2011 . All
%     'LC'         % LC      . C  . orig    . Zhai and Shah ACM-M 2006  . All
%     'RC'         % RC      . C  . orig    . Meng Wang et.al CVPR 2011 . All
%     %partial result, maybe biased due to train&test on same dataset but different files
%     'JiaLiSal'   % JIA-LI  . S  . 1/16    . Jia Li et.al IJCV 2010    . Partial ASD and MSRA
    
    
    % Saliency modeling models (for fixation prediction)
    'SAIM'       % AIM     . M  . 1/2     .
%     'SHouCVPR'   % SR      . M  . 64x64   . SRM % SKIP This as it is the same as SR
%     'SHouNIPS'   % ICL     . M  . orig    .
%     'SSUN'       % SUN     . M  . 1/2 - N .
    'SAWS'       % AWS     . M  . 1/2     .
    'SPQFT'      % PQFT    . M  . 400x400 .
    'SGBVS'      % GBVS    . M  . orig    .have problem when the image is under 128x128, same as GB
    'SITTI'      % ITTI    . C  . 1/16    .Itti model - same as IT
    'SITTI98'      % ITTI    . C  . 1/16    .Itti model - same as IT
%     'SSEO'       % SDSR    . M  . orig    .
%     'SJudd'      % Judd    . M  . orig    .
    
    
    % MAP map (Mean Annotation Map)
    'MEP'
    
    
    
    
%     % segmenters, not salient object detections
%     'SRS1' % SRS . Christian's model, SRS# where # is the #-th salient point
%     %     'SRS2'
%     %     'SRS3'
%     %     'SRS4'
%     %     'SRS5'
%     'Mishra' % MISHRA .
%     
%     % some combination maps
%     'CMAPplin' % plus linear
%     'CMAPmlin' % mult linear
%     'CMAPplog' % plus log(x/2)
%     'CMAPpexp' % plus exp(x^3)

    };

myPath = '/lab/raid/models/saliencyDetection/';

subplotNo = ceil(sqrt(length(modelUsed)+2));

% load('datasetRatio_2.mat');

for i=1:length(myDataset)
    eval(['myList = ' myDataset{i} 'getList;']);
    
    
%     figure
   
%     myOwnRatio = fullRatio{i};
    % sorted order
%     [a ratAsc] = sort(myOwnRatio,'ascend');
%     [a ratDes] = sort(myOwnRatio,'descend');
    
    % random order
    ratAsc = randperm(length(myList));
    ratDes = randperm(length(myList));
    
    % fixed order
    %ratAsc = [300 184 502];
    
    for j=1:numSampleImg
        printLog(myTic,'dataset:',myDataset{i},'sample img:',j,'/',numSampleImg );
        % ascend
        f1=figure;
        %subplot(numSampleImg,4,(j-1)*4 + 1)
        subplot(subplotNo,subplotNo,1)
        eval(['[za zb zc] = ' myDataset{i} 'getBox(myList{ratAsc(j)},1);'])
        if i==2 && j==5 % MSRA have duplicates
        eval(['[za zb zc] = ' myDataset{i} 'getBox(myList{ratAsc(j+1)},1);'])
        end
        title(['Orig-' myDataset{i}])
        %subplot(numSampleImg,4,(j-1)*4 + 2)
        subplot(subplotNo,subplotNo,2)
        imshow(zc,[]);
        title('GroundTruth')
        for mi=1:length(modelUsed)
            eval(['imName = ' myDataset{i} 'getList;'])
            if strcmp(modelUsed{mi},'MEP')
                theName = [myPath 'output/MEP_' myDataset{i} '.mat'];
            else
                theName = [myPath 'output/' modelUsed{mi} '/' myDataset{i} '/' rmExt(myList{ratAsc(j)}) '.mat'];
                if i==2 && j==5 % MSRA have duplicates
                    theName = [myPath 'output/' modelUsed{mi} '/' myDataset{i} '/' rmExt(myList{ratAsc(j+1)}) '.mat'];
                end
            end
            if exist(theName,'file')
                load(theName);
                subplot(subplotNo,subplotNo,mi+2);
                SM = imresize(SM,size(zc),'nearest');
                SM(isnan(SM)) = 0;
                imshow(SM,[]);
                title(modelUsed{mi});
            end
        end
        
        saveas(f1,['tmp/tmp2/' myDataset{i} '_' num2str(ratAsc(j)) '.eps'])
        
        close all
        
        % descend
        %subplot(numSampleImg,4,(j-1)*4 + 3)
%         eval(['[za zb zc] = ' myDataset{i} 'getBox(myList{ratDes(j)},1);'])
        %subplot(numSampleImg,4,(j-1)*4 + 4)
%         imshow(zc,[]);
    end

end

