% close all
clear all
myTic = tic;
% please load the results
load('score/union_2.mat');

%MSRA
dataSet='MSRA'; maxNum=100;
load('/lab/raid/models/saliencyDetection/score/MSRA_06-Feb-2012__a_3.mat')
myOwnRatio = dataScore{1};

% %SED
% dataSet='SED'; maxNum=50;
% load('/lab/raid/models/saliencyDetection/score/SED_03-Feb-2012__a_3.mat')
% myOwnRatio = dataScore{2};

% %SED2
% dataSet='SED2'; maxNum=50;
% load('/lab/raid/models/saliencyDetection/score/SED2_03-Feb-2012__a_3.mat')
% myOwnRatio = dataScore{3};

% %SOD
% dataSet='SOD'; maxNum=100;
% load('/lab/raid/models/saliencyDetection/score/SOD_04-Feb-2012__a_3.mat')
% myOwnRatio = dataScore{4};


thresholdValue = 0.4;
modelUsed = { ...
    %     % models that we have (have code) = all datasets calculated
        'Goferman'   % CA      . M  . max 250 . Gofferman et.al ICVS 2008 . All
    %     'EDS'        % EDS     . MC . orig    . Rosin et.al PRx/2009      . All
    'CBsal'      % CBSAL   . MC . orig    . Jiang et.al BMVC 2011     . All
    %     'Materias'   % JL      . M  . orig    . Jian Li BMVC 2011         . All
    %     'salLiu'     % LIU     . MC . max 200 . Liu et al. CVPR 2007      . All
    'SVO'        % SVO     . MC . orig    . Chang et al. ICCV 2011    . All
    %     'MSSS'       % MSSS    . M  . orig    . Achanta ICIP 2008         . All
    %     'AC'         % AC      . M  . orig    . Achanta ICVS 2008         . All
    %     'FTS'        % FT      . M  . orig    . Achanta CVPR 2009         . All
    %     'MichalGazit'% GAZIT   . M  . orig    . Gazit et.al ECCV2010      . All
    %     % some precomputed models
    %     %%%%%%'CA' % ASD only- This is Gofferman, Just keep this.
    %     %%%%%%'RCC' % Thresholded version of RC, ignore this
    %     'MZ'         % MZ      . S  . orig    . Ma and Zhang 2003         . ASD only
    %     'Valenti'    % VALENTI . S  . orig    . Valenti et.al ICCV 2009   . ASD and MSRA only
    %     'DAKlein'    % BITS    . S  . orig    . Klein & Frintrop ICCV 2011. All
    %     'PMehrani'   % MV      . S  . orig    . Mehrani et.al BMVC 2010   . ASD and SED1 only
    %     'LiuICIP'    % LIU-ICIP. S  . orig    . Liu et.al ICIP 2010       . ASD only
    %     'LiuIETIP'   % LIU-TiP . S  . orig    . Liu et.al TiP 2011        . ASD only
    %     'MengW'      % MENG    . S  . orig    .                           . ASD only
    %     %%precomputed on windoze machine
    %     %%%%% 'FT' % = FTS, ignore this model
    %     %%%%% 'SR' % This is the same as HouCVPR
    %     'HC'         % HC      . C  . orig    . Meng Wang et.al CVPR 2011 . All
        'LC'         % LC      . C  . orig    . Zhai and Shah ACM-M 2006  . All
    'RC'         % RC      . C  . orig    . Meng Wang et.al CVPR 2011 . All
    %     %partial result, maybe biased due to train&test on same dataset but different files
    %     'JiaLiSal'   % JIA-LI  . S  . 1/16    . Jia Li et.al IJCV 2010    . Partial ASD and MSRA
    %
    %
    %     % Saliency modeling models (for fixation prediction)
    %     'SAIM'       % AIM     . M  . 1/2     .
    %     'SHouCVPR'   % SR      . M  . 64x64   . SRM % SKIP This as it is the same as SR
    %     'SHouNIPS'   % ICL     . M  . orig    .
    %     'SSUN'       % SUN     . M  . 1/2 - N .
    %     'SAWS'       % AWS     . M  . 1/2     .
    %     'SPQFT'      % PQFT    . M  . 400x400 .
    %     'SGBVS'      % GBVS    . M  . orig    .have problem when the image is under 128x128, same as GB
    %     'SITTI'      % ITTI    . C  . 1/16    . Itti model - same as IT
    %     'SITTI98'    % ITTI98  . C  . 1/16    . Maxnorm
    %     'SSEO'       % SDSR    . M  . orig    .
    %     'SJudd'      % Judd    . M  . orig    .
    %
    %
    %     % MAP map (Mean Annotation Map)
    %     'MEP' % Mean Annotation Map . 500x500
    %     'IO'  % >>> Inter observer  . orig
    %
    %     % segmenters, not salient object detections
    %     'SRS1' % SRS . Christian's model, SRS# where # is the #-th salient point
    %     %     'SRS2'
    %     %     'SRS3'
    %     %     'SRS4'
    %     %     'SRS5'
    %     'Mishra' % MISHRA .
    
    % some combination maps, 3 best
    %     'CMAPmlin' % mult linear
%         'CMAPplin' % plus linear
    %     'CMAPplog' % plus log(x/2)
    %     'CMAPpexp' % plus exp(x^3)
    %     % 2 best
    %     'CMAP2mlin' % mult linear
    %     'CMAP2plin' % plus linear
    %     'CMAP2plog' % plus log(x/2)
    %     'CMAP2pexp' % plus exp(x^3)
    
    };
eval(['imName = ' dataSet 'getList;'])

permIdx=nchoosek(1:length(modelUsed),2);
dataScoreModel = zeros(length(imName),size(permIdx,1)); %fpp?

for imNo = 1:length(imName)
    eval(['[imBox imEachGT imAllGT] = ' dataSet 'getBox(imName{imNo});'])
    tmpSM=cell(length(modelUsed),1);
    printLog(myTic,'dataset',dataSet,'| imgNo',imNo,'/',length(imName) );
    for mm=1:length(modelUsed)
        
        if strcmp(modelUsed{mm},'MEP')
            theName = ['output/MEP_' dataSet '.mat'];
        else
            theName = ['output/' modelUsed{mm} '/' dataSet '/' rmExt(imName{imNo}) '.mat'];
        end
        if exist(theName,'file')
            load(theName);
            tmpSM{mm}=SM;
        end
    end
    
    for mi=1:size(permIdx,1)
        if isempty(tmpSM{permIdx(mi,1)}); continue; end
        if isempty(tmpSM{permIdx(mi,2)}); continue; end
        M1=double(tmpSM{permIdx(mi,1)});
        M2=double(tmpSM{permIdx(mi,2)});
        %resize
        if size(M1,3) > 1; M1 = rgb2gray(M1); end
        if size(M2,3) > 1; M2 = rgb2gray(M2); end
        M1 = imresize(M1,size(imAllGT),'nearest');
        M2 = imresize(M2,size(imAllGT),'nearest');
        %normalize
        M1 = M1 - min(min(M1));
        M1 = M1 ./ max(max(M1));
        M2 = M2 - min(min(M2));
        M2 = M2 ./ max(max(M2));
        %threshold
        M1 = M1 >= thresholdValue;
        M2 = M2 >= thresholdValue;
        if strcmp(dataSet,'MSRA')
            M1 = makeBoxMap(M1);
            M2 = makeBoxMap(M2);
        end
        M1 = imfill(M1,'holes');
        M2 = imfill(M2,'holes');
        dataScoreModel(imNo,mi)=mean2(M1&M2)/mean2(M1|M2);
%         subplot(1,2,1);imshow(M1,[]);
%         subplot(1,2,2);imshow(M2,[]);
%         pause(.3)
    end
    
end

za=mean(dataScoreModel,2);
zb=myOwnRatio;
figure
plot(zb,za,'.')
xlabel('Human')
xlim([0 1])
ylabel('Models')
ylim([0 1])

% %%%% MSRA results
% %h=human,m=models, d/a = dis/agree
% hdma=[905 3764 3893 4238 4959];
% hama=[526 598 911 1223 1597];
% hdmd=[3084 3520 3820 3856 3890];
% hamd=[295 3832 3997 4059 4333];
% 
% figure
% for i=1:5
%     subplot(4,5,i)
%     MSRAgetBox(imName{hdma(i)},3);
%     subplot(4,5,i+5)
%     MSRAgetBox(imName{hama(i)},3);
%     subplot(4,5,i+10)
%     MSRAgetBox(imName{hdmd(i)},3);
%     subplot(4,5,i+15)
%     MSRAgetBox(imName{hamd(i)},3);
% end


% %%%% SED1 results
% %h=human,m=models, d/a = dis/agree
% hdma=[2 11 29 78 93];
% hama=[16 37 58 77 97];
% hdmd=[10 22 49 71 98];
% hamd=[9 18 73 80 84];
% 
% figure
% for i=1:5
%     subplot(4,5,i)
%     SEDgetBox(imName{hdma(i)},3);
%     subplot(4,5,i+5)
%     SEDgetBox(imName{hama(i)},3);
%     subplot(4,5,i+10)
%     SEDgetBox(imName{hdmd(i)},3);
%     subplot(4,5,i+15)
%     SEDgetBox(imName{hamd(i)},3);
% end

% %%%% SED2 results
% %h=human,m=models, d/a = dis/agree
% hdma=[10 11 12 13 28];
% hama=[3 37 48 82 94];
% hdmd=[2 14 15 39 83];
% hamd=[4 18 64 75 78];
% 
% figure
% for i=1:5
%     subplot(4,5,i)
%     SED2getBox(imName{hdma(i)},3);
%     subplot(4,5,i+5)
%     SED2getBox(imName{hama(i)},3);
%     subplot(4,5,i+10)
%     SED2getBox(imName{hdmd(i)},3);
%     subplot(4,5,i+15)
%     SED2getBox(imName{hamd(i)},3);
% end

[a zzza]=sort(za);
[a zzzb]=sort(zb);
hdma=[];hama=[];hdmd=[];hamd=[];
ma=false(size(zzza));
md=false(size(zzza));
hd=false(size(zzzb));
ha=false(size(zzzb));
leI=0;
while length(hdma)<6 || length(hama)<6 || length(hdmd)<6 || length(hamd)<6
    ma(zzza(end-leI))=true;
    md(zzza(1+leI))=true;
    ha(zzzb(end-leI))=true;
    hd(zzzb(1+leI))=true;
    if length(hdma) < 6; hdma = find(hd & ma); end
    if length(hama) < 6; hama = find(ha & ma); end
    if length(hdmd) < 6; hdmd = find(hd & md); end
    if length(hamd) < 6; hamd = find(ha & md); end
    leI = leI + 1;
end

figure
for i=1:5
    subplot(4,5,i)
    eval([dataSet 'getBox(imName{hdma(i)},3);'])
    subplot(4,5,i+5)
    eval([dataSet 'getBox(imName{hama(i)},3);'])
    subplot(4,5,i+10)
    eval([dataSet 'getBox(imName{hdmd(i)},3);'])
    subplot(4,5,i+15)
    eval([dataSet 'getBox(imName{hamd(i)},3);'])
end