% please load the results
%colorCode={'m','c','r','g','b','k'};
%lineCode ={'-','--',':','-.'};

theCodes = { ...
    % models that we have (have code) = all datasets calculated
    'm-' ,1,'Goferman'   % CA      . M  . max 250 . Gofferman et.al ICVS 2008 . All
    'm--',1,'EDS'        % EDS     . MC . orig    . Rosin et.al PRx/2009      . All
    'm:' ,1,'CBsal'      % CBSAL   . MC . orig    . Jiang et.al BMVC 2011     . All
    'm-.',1,'Materias'   % JL      . M  . orig    . Jian Li BMVC 2011         . All
    'c-' ,1,'salLiu'     % LIU     . MC . max 200 . Liu et al. CVPR 2007      . All
    'c--',1,'SVO'        % SVO     . MC . orig    . Chang et al. ICCV 2011    . All
    'c:' ,1,'MSSS'       % MSSS    . M  . orig    . Achanta ICIP 2008         . All
    'c-.',1,'AC'         % AC      . M  . orig    . Achanta ICVS 2008         . All
    'r-' ,1,'FTS'        % FT      . M  . orig    . Achanta CVPR 2009         . All
    'r--',1,'MichalGazit'% GAZIT   . M  . orig    . Gazit et.al ECCV2010      . All
    % some precomputed models
    'r:' ,1,'MZ'         % MZ      . S  . orig    . Ma and Zhang 2003         . ASD only
    'r-.',1,'Valenti'    % VALENTI . S  . orig    . Valenti et.al ICCV 2009   . ASD and MSRA only
    'g-' ,1,'DAKlein'    % BITS    . S  . orig    . Klein & Frintrop ICCV 2011. All
    'g--',1,'PMehrani'   % MV      . S  . orig    . Mehrani et.al BMVC 2010   . ASD and SED1 only
    'g:' ,1,'LiuICIP'    % LIU-ICIP. S  . orig    . Liu et.al ICIP 2010       . ASD only
    'g-.',1,'LiuIETIP'   % LIU-TiP . S  . orig    . Liu et.al TiP 2011        . ASD only
    'b-' ,1,'MengW'      % MENG    . S  . orig    .                           . ASD only    
    %%precomputed on windoze machine
    'b--',1,'HC'         % HC      . C  . orig    . Meng Wang et.al CVPR 2011 . All
    'b:' ,1,'LC'         % LC      . C  . orig    . Zhai and Shah ACM-M 2006  . All
    'b-.',1,'RC'         % RC      . C  . orig    . Meng Wang et.al CVPR 2011 . All
    %partial result, maybe biased due to train&test on same dataset but different files
    'k-' ,1,'JiaLiSal'   % JIA-LI  . S  . 1/16    . Jia Li et.al IJCV 2010    . Partial ASD and MSRA
    % Saliency modeling models (for fixation prediction)
    'r-' ,1,'SAIM'       % AIM     . M  . 1/2     .
    'r--',1,'SHouCVPR'   % SR      . M  . 64x64   . SRM % SKIP This as it is the same as SR
    'r:' ,1,'SHouNIPS'   % ICL     . M  . orig    .
    'r-.',1,'SSUN'       % SUN     . M  . 1/2 - N .
    'g-' ,1,'SAWS'       % AWS     . M  . 1/2     .
    'g--',1,'SPQFT'      % PQFT    . M  . 400x400 .
    'g:' ,1,'SGBVS'      % GBVS    . M  . orig    .have problem when the image is under 128x128, same as GB
    'g-.',1,'SITTI'      % ITTI    . C  . 1/16    . Itti model - same as IT
    'b-' ,1,'SITTI98'    % ITTI98  . C  . 1/16    . Maxnorm
    'b--',1,'SSEO'       % SDSR    . M  . orig    .
    'b:' ,1,'SJudd'      % Judd    . M  . orig    .
    'b-.',1,'SWalther'
    
    % MAP map (Mean Annotation Map)
    'b-' ,2,'MEP' % Mean Annotation Map
    'r-' ,2,'IO'  % >>> Inter observer
    
    % segmenters, not salient object detections
    'k--',1,'SRS1' % SRS . Christian's model, SRS# where # is the #-th salient point
    'k:' ,1,'Mishra' % MISHRA .
    
    % some combination maps
    'b--',2,'CMAPmlin' % mult linear
    'r--',2,'CMAPplin' % plus linear
    'g--',2,'CMAPplog' % plus log(x/2)
    'm--',2,'CMAPpexp' % plus exp(x^3)

    };


%  idx = 21:30; % S___, the saliency model
% idx = [1:20 31:33]; %salient objects
%idx = [1:20 31:37]; %salient objects with map thing
% idx = [1:20 38 31:33 34:37]; %salient objects with map thing + MengW

% new version (sorted)
% idx=1
%     idx = [1:21 33:40]; %salient objects
%     idx = [22:34]; %salient models

%   modelUsed = modelUsed(idx);
%   scorePRpr = scorePRpr(:,idx);
%   scorePRre = scorePRre(:,idx);
%   scoreROCf = scoreROCf(:,idx);
%   scoreROCt = scoreROCt(:,idx);
% reorder the hard-coded lines
zz=zeros(size(modelUsed));
for i=1:length(modelUsed)
    zz(i)=find(strcmp(modelUsed{i},theCodes(:,3)));
end
theCodes  = theCodes(zz,:);

%%%%% Checking value existed or not
idx=true(1,length(modelUsed)); %all
for mm=1:length(modelUsed)
    pr = vertcat(scorePRpr{:,mm});
    if isempty(pr)
        idx(mm) = false;
    end
end
modelUsed = modelUsed(idx);
scorePRpr = scorePRpr(:,idx);
scorePRre = scorePRre(:,idx);
scoreROCf = scoreROCf(:,idx);
scoreROCt = scoreROCt(:,idx);
theCodes  = theCodes(idx,:);

% colorCode={'m','c','r','g','b','k'};
% lineCode ={'-','--',':','-.'};
% theCodes=cell(length(colorCode)*length(lineCode),1);
% for i=1:length(colorCode)
%     for j=1:length(lineCode)
%         theCodes{(i-1)*length(lineCode)+j} = [colorCode{i} lineCode{j}];
%     end
% end

Fmeasure = zeros(length(modelUsed),1);
beta=.3; % Fmeasure
%figure;
subplot(2,2,1)
hold on
for mm=1:length(modelUsed)
    pr = vertcat(scorePRpr{:,mm});
    re = vertcat(scorePRre{:,mm});
    % remove all NaNs
    ipr = mean(pr,2); ire = mean(re,2);
    idx = ~isnan(ipr) & ~isnan(ire);
    pr = pr(idx,:);
    re = re(idx,:);
    pr(isnan(pr)) = 0;
    re(isnan(re)) = 0;
    %plot(mean(re),mean(pr),'color',rand(1,3));
    plot(mean(re),mean(pr),theCodes{mm,1},'linewidth',theCodes{mm,2} );
    Fmeasure(mm) = ((1+ beta)*mean2(pr) * mean2(re)) / (beta*mean2(re) + mean2(pr));
end
hold off
ylim([0 1])
xlim([0 1])
xlabel('recall')
ylabel('precision')
legend(modelUsed);

%figure;
subplot(2,2,2)
bar(Fmeasure)
set(gca,'ylim',[0 1])
set(gca,'xlim',[.5 length(modelUsed)+.5])
set(gca, 'XTick',  1:length(modelUsed))
set(gca, 'XTickLabel', modelUsed)
xticklabel_rotate([],90)

%aucs = zeros(length(modelUsed),1);
meanaucs = zeros(length(modelUsed),1);
stdaucs = zeros(length(modelUsed),1);
%figure;
subplot(2,2,3)
hold on
for mm=1:length(modelUsed)
    tpp = vertcat(scoreROCt{:,mm});
    fpp = vertcat(scoreROCf{:,mm});
    % remove all NaNs
    itpp = mean(tpp,2); ifpp = mean(fpp,2);
    idx = ~isnan(itpp) & ~isnan(ifpp);
    tpp = tpp(idx,:);
    fpp = fpp(idx,:);
    tpp(isnan(tpp)) = 0;
    fpp(isnan(fpp)) = 0;
    %plot(mean(fpp),mean(tpp),'color',rand(1,3));
    plot(mean(fpp),mean(tpp),theCodes{mm,1},'linewidth',theCodes{mm,2} );
    %aucs(mm) = -trapz(mean(fpp),mean(tpp));
    tmpaucs=zeros(size(fpp,1),1);
    for mi=1:size(fpp,1)
        tmpaucs(mi) = -trapz(fpp(mi,:),tpp(mi,:));
    end
    meanaucs(mm)=mean(tmpaucs);
    stdaucs(mm) =std(tmpaucs)/sqrt(length(tmpaucs));
end
plot(0:.1:1,0:.1:1,'k', 'linewidth',3)
hold off
ylim([0 1])
xlim([0 1])
ylabel('true positive')
xlabel('false positive')
legend(modelUsed);

%figure;
subplot(2,2,4)
barweb(meanaucs,stdaucs,[],[],[],'Models','AUC',[],[],modelUsed)
ylim([.5 1])
% bar(aucs)
% set(gca,'ylim',[.5 1])
% set(gca,'xlim',[.5 length(modelUsed)+.5])
% set(gca, 'XTick',  1:length(modelUsed))
% set(gca, 'XTickLabel', modelUsed)
% xticklabel_rotate([],90)