% please load the results


% idx = 21:30; % S___, the saliency model
idx = [1:20 31:33]; %salient objects
modelUsed = modelUsed(idx);
scorePRpr = scorePRpr(:,idx);
scorePRre = scorePRre(:,idx);
scoreROCf = scoreROCf(:,idx);
scoreROCt = scoreROCt(:,idx);

%%%%% Checking value existed or not
idx=true(1,length(modelUsed)); %all
for mm=1:length(modelUsed)
    pr = vertcat(scorePRpr{:,mm});
    if isempty(pr)
        idx(mm) = false;
    end
end
modelUsed = modelUsed(idx);
scorePRpr = scorePRpr(:,idx);
scorePRre = scorePRre(:,idx);
scoreROCf = scoreROCf(:,idx);
scoreROCt = scoreROCt(:,idx);

colorCode={'m','c','r','g','b','k'};
lineCode ={'-','--',':','-.'};
theCodes=cell(length(colorCode)*length(lineCode),1);
for i=1:length(colorCode)
    for j=1:length(lineCode)
        theCodes{(i-1)*length(lineCode)+j} = [colorCode{i} lineCode{j}];
    end
end

Fmeasure = zeros(length(modelUsed),1);
beta=.3; % whats this?
figure; hold on
for mm=1:length(modelUsed)
    pr = vertcat(scorePRpr{WWW,mm});
    re = vertcat(scorePRre{WWW,mm});
    % remove all NaNs
    pr(isnan(pr)) = 0;
    re(isnan(re)) = 0;
    %plot(mean(re),mean(pr),'color',rand(1,3));
    plot(mean(re),mean(pr),theCodes{mod(mm-1,length(theCodes))+1},'linewidth',ceil(mm./length(theCodes)) );
    Fmeasure(mm) = ((1+ beta)*mean2(pr) * mean2(re)) / (beta*mean2(re) + mean2(pr));
end
hold off
ylim([0 1])
xlim([0 1])
xlabel('recall')
ylabel('precision')
legend(modelUsed);

figure;
bar(Fmeasure)
set(gca, 'XTick',  1:length(modelUsed))
set(gca, 'XTickLabel', modelUsed)

aucs = zeros(length(modelUsed),1);
figure; hold on
for mm=1:length(modelUsed)
    tpp = vertcat(scoreROCt{WWW,mm});
    fpp = vertcat(scoreROCf{WWW,mm});
    % remove all NaNs
    tpp(isnan(tpp)) = 0;
    fpp(isnan(fpp)) = 0;
    %plot(mean(fpp),mean(tpp),'color',rand(1,3));
    plot(mean(fpp),mean(tpp),theCodes{mod(mm-1,length(theCodes))+1},'linewidth',ceil(mm./length(theCodes)) );
    aucs(mm) = -trapz(mean(fpp),mean(tpp));
end
plot(0:.1:1,0:.1:1,'k', 'linewidth',2)
hold off
ylim([0 1])
xlim([0 1])
ylabel('true positive')
xlabel('false positive')
legend(modelUsed);

figure;
bar(aucs)
set(gca,'ylim',[.5 1])
set(gca,'xlim',[.5 length(modelUsed)+.5])
set(gca, 'XTick',  1:length(modelUsed))
set(gca, 'XTickLabel', modelUsed)
