function errorbar_region(x, me, st, leg)
% function errorbar_region(x, me, st, leg) plot error bars as region.  
% x:   x index
% me:  mean (MxN matrix), each column is one data set, different column
%      represents different data set
% st:  standard deviation or width of the errorbar
% leg: legend

if nargin<4
    leg=[];
end

c = {'r', 'b', 'g', 'c', 'm', 'y', 'k', 'w'};
%c = {'b','r'};
[~, col] = size(me);
% x = [1:1:row];

% fill region
% figure
set(0, 'showhiddenHandles', 'off');
% set(gcf, 'renderer', 'painters', 'rendererMode', 'manual');
hold on;
for i=1:col     
    low = me(:,i)'-st(:,i)';
    high = fliplr(me(:,i)'+st(:,i)');
    regY = [low high];
    regX = [x fliplr(x)];
    p = fill(regX, regY, c{i});
    %set(p, 'handlevisibility', 'off');
    set(p, 'edgeColor', get(p, 'facecolor'));
    %set(p,'EdgeAlpha', 0, 'FaceAlpha', 0.5, 'HandleVisibility', 'off')
    set(p,'EdgeAlpha', 0, 'FaceAlpha', 0.5)
end

% plot mean
for i=1:col
    p = plot(x, me(:,i), c{i});
    set(p,'LineWidth',2);
end
hold off;

% legend
if ~isempty(leg)
    ct = legend(leg);
    set(ct,'fontsize',8);
    legend('boxoff');
end
