function [segment, sal] = ObjSal(filename)
% demo.m

% make superpixel
fprintf('Making superpixels...'); tic;
segment = SegmentImage(filename);
toc;

% bottom-up saliency
fprintf('Estimating bottom-up saliency...'); tic;
S = CSal(imread(segment.imgName), 100);
segment.saliency = imresize(S, size(segment.seg));
toc;

% the interaction between objectness and saliency
fprintf('Fusing generic objectness and visual saliency...'); tic;
[sal.x_sal, sal.x_obj, sal.init_obj, sal.wiao_obj, sal.boxes, sal.ccScore] = InterSalObj(segment);
toc;

% draw results
ShowResult(segment, sal, 10);

segment.ourSaliency = SPSalMap(segment, sal.x_sal);