% demo.m

% make superpixel
fprintf('Making superpixels...'); tic;
segment = SegmentImage('test1.png');
toc;

% bottom-up saliency
fprintf('Estimating bottom-up saliency...'); tic;
S = CSal(imread(segment.imgName), 200);
segment.saliency = imresize(S, size(segment.seg));
toc;

% the interaction between objectness and saliency
fprintf('Fusing generic objectness and visual saliency...'); tic;
[sal.x_sal, sal.x_obj, sal.init_obj, sal.wiao_obj, sal.boxes, sal.ccScore] = InterSalObj(segment);
toc;

% draw results
ShowResult(segment, sal, 10);

% to generate the saliency map, call this function 
% map = SPSalMap(segment, sal.x_sal);