function ShowResult(segment, sal, nTopWin)
close all;

img = imread(segment.imgName);

% salient objects
x_obj = sal.x_obj.*sal.ccScore(:);
[~,scOrder] = sort(x_obj, 'descend');
figure('Name','Our salient objects'); subplot('position', [0,0,1,1]); imagesc(img);
hold on; drawBoxes(sal.boxes(scOrder(1:nTopWin),:));

% objectness
[~,scOrder] = sort(sal.x_obj, 'descend');
figure('Name','Our objectness'); subplot('position', [0,0,1,1]); imagesc(img);
hold on; drawBoxes(sal.boxes(scOrder(1:nTopWin),:));

% objectness in the paper "what is an object?"
[~,scOrder] = sort(sal.wiao_obj, 'descend');
figure('Name','Objectness of Alexe et al.'); subplot('position', [0,0,1,1]); imagesc(img);
hold on; drawBoxes(sal.boxes(scOrder(1:nTopWin),:));

% saliency map
map = SPSalMap(segment, sal.x_sal);
figure('Name','Our saliency map'); subplot('position', [0,0,1,1]); imagesc(map);

% bottom-up saliency
figure('Name','Bottom-up saliency (Goferman et al.)'); subplot('position', [0,0,1,1]); imagesc(segment.saliency);
