% function x_obj = FindX_Obj(score_td, spToCC, spInWin, x_sal, x_objOld, c_2)
% % score_td: score from training data
% 
% nObj = size(spToCC,2);
% 
% deno = spInWin*x_objOld;   % denominator
% tmp = max(deno, eps);
% norSPToCC = spToCC ./ repmat(tmp, [1 nObj]);
% 
% vec = double(x_sal'*norSPToCC*2) + 2*c_2*score_td';
% 
% quad = double(norSPToCC'*norSPToCC+c_2*eye(nObj) );
% 
% % lambda = 2;
% %  + lambda*sum(x) 
% %  + square_pos( norm(x-score_td) ) 
% cvx_begin quiet
%     variable x(nObj,1);
%     minimize( x'*quad*x - vec*x + c_2*score_td'*score_td );
%     x>=0;
%     x<=1;
% cvx_end
% 
% x(x<0) = 0;
% x_obj = x;


function x_obj = FindX_Obj(score_td, spToCC, spInWin, x_sal, x_objOld, c_2)
% score_td: score from training data

nObj = size(spToCC,2);

deno = spInWin*x_objOld;   % denominator
noZeros = deno~=0;
% if(sum(deno<.00001)>0)
%     fprintf('problem.\n');
% end
tmp = max(deno, eps);
norSPToCC = spToCC ./ repmat(tmp, [1 nObj]);
norSPToCC(noZeros==0, :) = 0;

x_sal_sub = double(x_sal);

% vec = double(x_sal(noZeros)'*norSPToCC*2);

% quad = double(norSPToCC'*norSPToCC);

% lambda = 2;
%  + lambda*sum(x) 
%  + square_pos( norm(x-score_td) ) 
cvx_begin quiet
    variable x(nObj,1);
    minimize( square_pos( norm(norSPToCC*x - x_sal_sub) ) + c_2*square_pos( norm(x-score_td) ) );
    x>=0;
    x<=1;
cvx_end


% cvx_begin quiet
%     variable x(nObj,1);
%     minimize( x'*quad*x - vec*x + c_2*square_pos( norm(x-score_td) ) );
%     x>=0;
%     x<=1;
% cvx_end


% if(strncmpi(cvx_status, 'Ina', 3))
%     fprintf('inaccurate.\n');
% end
x(x<0) = 0;
x_obj = x;






%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
% old version
% function x_obj = FindX_Obj(score_td, score_id)
% % score_td: score from training data
% % score_id: score dependent on image
% 
% % spSalPrior = SPSalPrior(segment,dataName);    % compute once
% % score_id = ImgDepScore_SP((spSal+spSalPrior)/2, segment(idx), .5, spInWin, allboxes);
% % score = (score_id + allboxes(:,5))/2;
% 
% x_obj = (score_td+score_id)/2;