function [spInWin spToCC ccScore] = SPInWinV1(segment, win)

% img = imread(segment.imgName);
[h w] = size(segment.seg);
h = h+1;
w = w+1;

nWin = size(win,1);
xmin = round(win(:,1));
ymin = round(win(:,2));
xmax = round(win(:,3))+1;
ymax = round(win(:,4))+1;

p11 = (xmax-1)*h + ymax;
p10 = (xmax-1)*h + ymin;
p01 = (xmin-1)*h + ymax;
p00 = (xmin-1)*h + ymin;

dSPInWinThres = .8;
spInWin = zeros(segment.stat.P, nWin);

for k=1:segment.stat.P
    segMask = segment.seg==k;
    nSegSize = sum(segMask(:)==1);
    % Integral Image
    segII = computeIntegralImage(segMask);
    tmp = (segII(p11) + segII(p00) - segII(p10) - segII(p01))/nSegSize;
%     spInWin(k,:) = tmp;
%     spToCC(k,:) = ccScore.*tmp;
    spInWin(k,tmp>=dSPInWinThres) = 1;
end

spToCC = zeros(segment.stat.P, nWin);
ccScore = WinCCSP(segment, spInWin);

for k=1:segment.stat.P
    spToCC(k,spInWin(k,:)==1) = ccScore(spInWin(k,:)==1);
end