function spHist = SPLabHist(segment)

textonImg = MkTextonImg(segment.imgName);

[h w nBank] = size(textonImg);

% sub-sample
[xSub ySub] = meshgrid(2:4:w, 2:4:h);
idxSub = (xSub-1)*h+ySub;
data = reshape(textonImg, [], nBank);

dataSub = data(idxSub,:);

K = 20;

option = zeros(14,1);  option(5) = 1;
C = kmeansNetlab(zeros(K, nBank), dataSub, option); % item * cluster
dis = L2_distance_mex(data', C');

[~, A] = min(dis, [], 2);
% [C,A] = vl_ikmeans(data,K);

texImg = reshape(A, h, w);

% figure; subplot('position', [0,0,1,1]); imagesc(texImg);

assIdx = zeros(h*w, K);
for k=1:K
    assIdx(texImg==k,k) = 1;
end

spHist = zeros(segment.stat.P, K);
for k=1:segment.stat.P
    spHist(k,:) = sum(assIdx(segment.seg==k,:));
end
spHist = spHist';
return;

function textonImg = MkTextonImg(imgName)
img = imread(imgName);

[h,w,c] = size(img);
if(c==1)
    c = 3;
    img = reshape(repmat(img(:), [1 c]), [h w c]);
end

C = makecform('srgb2lab');
img = im2double(applycform(img, C));


nBank = 17;
% load('textonRange.mat', 'minTexton', 'maxTexton');

textonImg = TextonFeature(img);

a = reshape(textonImg, [], nBank);
minTexton = min(a); maxTexton = max(max(a)-minTexton, eps);
a = a - ones(size(a,1),1)*minTexton;
a = a./(ones(size(a,1),1)*maxTexton);

height = size(img,1);   width = size(img,2);

% [X Y] = meshgrid(1:width, 1:height);
% a = [a, uint8(X(:)/width*3), uint8(Y(:)/height*3)];
textonImg = reshape(a, height, width, nBank);

