function probWin = WinCCSP(segment, spInWin)
% color constrast
% spInWin: [nSP*nWin]

spHist = SPLabHist(segment);

nbMtx = NbMtx(segment);
nbSPOfWin = nbMtx * spInWin;
nbSPOfWin(nbSPOfWin>0) = 1;
nbSPOfWin = nbSPOfWin - spInWin;
nbSPOfWin(nbSPOfWin>0) = 1;
nbSPOfWin(nbSPOfWin<0) = 0;

winHist = spHist * spInWin;
nbWinHist = spHist * nbSPOfWin;

% normalize
winHist = winHist./repmat(max(sum(winHist),eps), [size(winHist,1), 1]);
nbWinHist = nbWinHist./repmat(max(sum(nbWinHist),eps), [size(winHist,1), 1]);
probWin = sum(((winHist-nbWinHist).^2)./max((winHist+nbWinHist)/2, eps));
probWin = 1./(1+exp(-(probWin-mean(probWin))));
return


function nbMtx = NbMtx(segment)
% neighbor matrix
nbMtx = zeros(segment.stat.P);
for k=1:segment.stat.E
    nbMtx(segment.pairSeg(k,1), segment.pairSeg(k,2)) = 1;
    nbMtx(segment.pairSeg(k,2), segment.pairSeg(k,1)) = 1;
end